Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD

## es.inteco.xbrl.lenlocpenloc.config
Class ConfigurationManager

    java.lang.Object
      es.inteco.xbrl.lenlocpenloc.config.ConfigurationManager

    public class ConfigurationManager

extends java.lang.Object

Clase de configuración usada para consultar la información necesaria en los procesos de transformación de formato común a XBRL y viceversa.
Mediante esta clase se accede al fichero de configuración global.xml y a los mapas definidos a partir de la taxonomía para facilitar los procesos de transformación.
Para mantener la información lo más eficientemente posible, utiliza una caché interna basada en ehCache y la cual puede ser configurada mediante el fichero de configuración ehcache.xml.
Para conocer más sobre cómo configurar la caché, puede visitar la web del proyecto la cual se encuentra en la siguiente dirección http://ehcache.sourceforge.net
Tanto el fichero global.xml como el resto de ficheros de configuración correspondientes a los mapas, los cuales se encuentran bajo el directorio resources/ENLOCMaps, son leídos mediante Castor.
Cuando los mapas son deserializados mediante Castor, son encapsulados mediante la clase ConfigMap, la cual crea tablas de índices de modo que el acceso a los elementos sea lo más eficiente posible.
Proyecto: API XBRL-LENLOCPENLOC2010 - Grupo de utilidades y librerías en código abierto para facilitar la integración del formato XBRL en las herramientas software de gestión de terceros aislándose de la complejidad en el procesamiento del modelo de datos de las taxonomías. Ayudando de esta forma a las entidades locales en la labor de realización de informes XBRL y asegurar el éxito en el reporte de presupuestos y liquidación de presupuestos de las entidades locales en formato XBRL

Version:
  1.0, 24/06/2009
Author:
  difusioncalidad@inteco.es

Method Summary
`boolean` | `existModule(java.lang.String moduleID)` Comprueba si existe configuración para un módulo concreto.
`java.lang.String` | `getBaseUrl(java.lang.String reportID)` Devuelve la URL base que usa el schemaRef de un report.
`NsItem[]` | `getBasicNamespaces(java.lang.String idReport)` Obtiene la lista de espacios de nombres básicos que debe contener una instancia XBRL correspondiente a un report dado.
`Global` | `getGlobal()` Devuelve un objeto de tipo Global.
`ConfigReport` | `getGlobalReportFromSchemaRef(java.lang.String schemaRef)` Devuelve la configuración de un Report para un schemaRef dado.
`ConceptMap` | `getInfoByInputID(java.lang.String reportID, java.lang.String moduleID, java.lang.String inputID)` Localiza un ConceptMap mediante el identificador del report, el identificador del módulo y el identificador de entrada, inputID del propio ConceptMap.
`ConceptMap` | `getInfoByOutputID(java.lang.String reportID, java.lang.String moduleID, java.lang.String outputID)` Localiza un ConceptMap mediante el identificador del report, el identificador del módulo y el identificador de entrada, outputID del propio ConceptMap y el dominio, para aquellos conceptos que pertenecen a mapas dimensionales.
`ConceptMap` | `getInfoByOutputID(java.lang.String reportID, java.lang.String moduleID, java.lang.String outputID, java.lang.String dimension, java.lang.String member)` Localiza un ConceptMap mediante el identificador del report, el identificador del módulo y el identificador de entrada, outputID del propio ConceptMap, la dimensión y el miembro, para aquellos conceptos que pertenecen a mapas dimensionales.
`java.lang.String` | `getInfoToTranslate(java.lang.String reportID, java.lang.String moduleID, java.lang.String outputID)` Localiza un ConceptMap mediante el identificador del report, el identificador del módulo y el identificador de entrada, outputID del propio ConceptMap y el dominio, para aquellos conceptos que pertenecen a mapas dimensionales.
`java.lang.String` | `getInfoToTranslate(java.lang.String reportID, java.lang.String moduleID, java.lang.String prefix, java.lang.String outputID)` Localiza un ConceptMap mediante el identificador del report, el identificador del módulo y el identificador de entrada, outputID del propio ConceptMap y el dominio, para aquellos conceptos que pertenecen a mapas dimensionales.
`static ConfigurationManager` | `getInstance()` Obtiene la referencia a la configuración de mapas necesaria para realizar la transformación de formato común a XBRL y viceversa.
`java.lang.String` | `getModuleID(java.lang.String reportID, java.lang.String outputID, java.lang.String dimension, java.lang.String member)` Obtiene el identificador del módulo para un identificador de report, dimension, member y ConceptMap dados.
`java.math.BigDecimal` | `getOrderToReplace(java.lang.String reportID, java.lang.String moduleID, java.lang.String itemID, java.lang.String parentInputID)` Obtiene y devuelve el orden que debe llevar un elemento dentro de la tupla en la que está anidado.
`java.lang.String` | `getShemaRefUri(java.lang.String reportID)` Obtiene la URI para el schemaRef del report indicado.
`java.lang.String` | `getTargetNamespace(java.lang.String reportID)` Devuelve el targetNamespace para el report indicado mediante un identificador dado.
`java.lang.String` | `getUnit(java.lang.String unitKey, java.lang.String reportID)` Devuelve el code correspondiente a un unitKey e identificador de report dado.
`java.lang.String` | `getUnitPrefix(java.lang.String unitKey, java.lang.String reportID)` Devuelve el prefijo correspondiente a un identificador de report y una clave de unidad.

Methods inherited from class java.lang.Object
`equals, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

Method Detail

### getInstance

    public static final ConfigurationManager getInstance()
                                                  throws DocumentNotFoundException,
                                                         ConfigException

  Obtiene la referencia a la configuración de mapas necesaria para realizar la transformación de formato común a XBRL y viceversa.

  Returns:
    referencia a la configuración
  Throws:
    `ConfigException` - si se produce un error de configuración.
    `DocumentNotFoundException` - si no se encuentra el documento en el sistema

### existModule

    public boolean existModule(java.lang.String moduleID)

  Comprueba si existe configuración para un módulo concreto.

  Parameters:
    `moduleID` - identificación del módulo que se está buscando.
  Returns:
    boolean true si se ha encontrado el módulo.

### getBasicNamespaces

    public NsItem[] getBasicNamespaces(java.lang.String idReport)
                                throws ConfigException

  Obtiene la lista de espacios de nombres básicos que debe contener una instancia XBRL correspondiente a un report dado.

  Parameters:
    `idReport` - identificador del report
  Returns:
    lista de espacios de nombres
  Throws:
    `ConfigException` - si se produce un error de configuración.

### getShemaRefUri

    public java.lang.String getShemaRefUri(java.lang.String reportID)
                                    throws ConfigException

  Obtiene la URI para el schemaRef del report indicado.

  Parameters:
    `reportID` - identificador del report
  Returns:
    String contenedor de la URI encontrada
  Throws:
    `ConfigException` - si se produce un error de configuración.

### getTargetNamespace

    public java.lang.String getTargetNamespace(java.lang.String reportID)
                                        throws ConfigException

  Devuelve el targetNamespace para el report indicado mediante un identificador dado.

  Parameters:
    `reportID` - identificador del report consultado
  Returns:
    String contenedor del targetNamespace consultado
  Throws:
    `ConfigException` - si se produce un error de configuración.

### getBaseUrl

    public java.lang.String getBaseUrl(java.lang.String reportID)
                                throws ConfigException

  Devuelve la URL base que usa el schemaRef de un report.

  Parameters:
    `reportID` - identificador del report
  Returns:
    URL base
  Throws:
    `ConfigException` - si se produce un error de configuración.

### getUnit

    public java.lang.String getUnit(java.lang.String unitKey,
                                    java.lang.String reportID)
                             throws ConfigException

  Devuelve el code correspondiente a un unitKey e identificador de report dado.

  Parameters:
    `unitKey` - identificador de la unidad para la cual se hace la consulta
    `reportID` - identificador del report que contiene la unidad
  Returns:
    codido de la unidad cousltada
  Throws:
    `ConfigException` - si se produce un error de configuración.

### getUnitPrefix

    public java.lang.String getUnitPrefix(java.lang.String unitKey,
                                          java.lang.String reportID)
                                   throws ConfigException

  Devuelve el prefijo correspondiente a un identificador de report y una clave de unidad.

  Parameters:
    `unitKey` - clave de la unidad consultada
    `reportID` - identificador del report que contiene la unidad consultada
  Returns:
    prefijo de la unidad dada
  Throws:
    `ConfigException` - si se produce un error de configuración.

### getInfoByInputID

    public ConceptMap getInfoByInputID(java.lang.String reportID,
                                       java.lang.String moduleID,
                                       java.lang.String inputID)
                                throws ConfigException,
                                       DocumentNotFoundException

  Localiza un ConceptMap mediante el identificador del report, el identificador del módulo y el identificador de entrada, inputID del propio ConceptMap.

  Parameters:
    `reportID` - identifcador del report
    `moduleID` - identificador del módulo
    `inputID` - identificador de entrada del ConceptMap
  Returns:
    referencia al ConceptMap encontrado
  Throws:
    `DocumentNotFoundException` - si se produce un error al no encontrarse un fichero.
    `ConfigException` - si se produce un error de configuración.

### getInfoByOutputID

    public ConceptMap getInfoByOutputID(java.lang.String reportID,
                                        java.lang.String moduleID,
                                        java.lang.String outputID,
                                        java.lang.String dimension,
                                        java.lang.String member)
                                 throws ConfigException,
                                        DocumentNotFoundException

  Localiza un ConceptMap mediante el identificador del report, el identificador del módulo y el identificador de entrada, outputID del propio ConceptMap, la dimensión y el miembro, para aquellos conceptos que pertenecen a mapas dimensionales.

  Parameters:
    `reportID` - identificador del report
    `moduleID` - identificador del módulo
    `outputID` - identificador de salida del ConceptMap
    `dimension` - nombre de la dimension
    `member` - nombre del miembro
  Returns:
    referencia al ConceptMap encontrado
  Throws:
    `DocumentNotFoundException` - si se produce un error al no encontrarse un documento.
    `ConfigException` - si se produce un error de configuración.

### getInfoByOutputID

    public ConceptMap getInfoByOutputID(java.lang.String reportID,
                                        java.lang.String moduleID,
                                        java.lang.String outputID)
                                 throws ConfigException,
                                        DocumentNotFoundException

  Localiza un ConceptMap mediante el identificador del report, el identificador del módulo y el identificador de entrada, outputID del propio ConceptMap y el dominio, para aquellos conceptos que pertenecen a mapas dimensionales.

  Parameters:
    `reportID` - identifcador del report
    `moduleID` - identificador del módulo
    `outputID` - identificador de salida del ConceptMap
  Returns:
    referencia al ConceptMap encontrado
  Throws:
    `DocumentNotFoundException` - si se produce un error al no encontrarse un documento.
    `ConfigException` - si se produce un error de configuración.

### getInfoToTranslate

    public java.lang.String getInfoToTranslate(java.lang.String reportID,
                                               java.lang.String moduleID,
                                               java.lang.String prefix,
                                               java.lang.String outputID)
                                        throws ConfigException,
                                               DocumentNotFoundException

  Localiza un ConceptMap mediante el identificador del report, el identificador del módulo y el identificador de entrada, outputID del propio ConceptMap y el dominio, para aquellos conceptos que pertenecen a mapas dimensionales. Teniendo en cuenta la traducción entre elementos XBRL y codigos de formato común.

  Parameters:
    `reportID` - identifcador del report
    `moduleID` - identificador del módulo
    `outputID` - identificador de salida del ConceptMap
  Returns:
    referencia al ConceptMap encontrado
  Throws:
    `DocumentNotFoundException` - si se produce un error al no encontrarse un documento.
    `ConfigException` - si se produce un error de configuración.

### getInfoToTranslate

    public java.lang.String getInfoToTranslate(java.lang.String reportID,
                                               java.lang.String moduleID,
                                               java.lang.String outputID)
                                        throws ConfigException,
                                               DocumentNotFoundException

  Localiza un ConceptMap mediante el identificador del report, el identificador del módulo y el identificador de entrada, outputID del propio ConceptMap y el dominio, para aquellos conceptos que pertenecen a mapas dimensionales. Teniendo en cuenta la traducción entre elementos XBRL y codigos de formato común.

  Parameters:
    `reportID` - identifcador del report
    `moduleID` - identificador del módulo
    `outputID` - identificador de salida del ConceptMap
  Returns:
    referencia al ConceptMap encontrado
  Throws:
    `DocumentNotFoundException` - si se produce un error al no encontrarse un documento.
    `ConfigException` - si se produce un error de configuración.

### getModuleID

    public java.lang.String getModuleID(java.lang.String reportID,
                                        java.lang.String outputID,
                                        java.lang.String dimension,
                                        java.lang.String member)
                                 throws ConfigException,
                                        DocumentNotFoundException

  Obtiene el identificador del módulo para un identificador de report, dimension, member y ConceptMap dados. Indica qué módulo contiene el ConceptMap dado.

  Parameters:
    `reportID` - identificador del report.
    `outputID` - identificador de salida del ConceptMap.
    `dimension` - dimensión.
    `member` - member nombre del miembro de la dimensión.
  Returns:
    Identificador del módulo contenedor del ConceptMap.
  Throws:
    `DocumentNotFoundException` - si se produce un error al no encontrarse un documento.
    `ConfigException` - si se produce un error de configuración.

### getGlobalReportFromSchemaRef

    public ConfigReport getGlobalReportFromSchemaRef(java.lang.String schemaRef)

  Devuelve la configuración de un Report para un schemaRef dado.

  Parameters:
    `schemaRef` - schemaRef del módulo a localizar.
  Returns:
    configuración del report encontrado

### getGlobal

    public Global getGlobal()

  Devuelve un objeto de tipo Global.

  Returns:
    Objeto del tipo Global

### getOrderToReplace

    public java.math.BigDecimal getOrderToReplace(java.lang.String reportID,
                                                  java.lang.String moduleID,
                                                  java.lang.String itemID,
                                                  java.lang.String parentInputID)
                                           throws ConfigException

  Obtiene y devuelve el orden que debe llevar un elemento dentro de la tupla en la que está anidado.

  Parameters:
    `reportID` - id del report
    `moduleID` - id del module
    `itemID` - id del item
    `parentInputID` - codigo de la tupla padre
  Returns:
    BigDecimal con el order correcto
  Throws:
    `ConfigException` - si se produce un error de configuración.

Overview | Package | Class | Use | Tree | Deprecated | Index | Help
PREV CLASS NEXT CLASS | FRAMES NO FRAMES
SUMMARY: NESTED | FIELD | CONSTR | METHOD | DETAIL: FIELD | CONSTR | METHOD